/* =========================================================================
                                                                           |
    Скрипты: для макета ДЗЕН страницы.                                     |
                                                                           |
    --------------------------------------------------------------------   |
    ImperaCMS.ru - отличный скрипт для создания сайта. На этой системе     |
    создают готовые сайты с минимальным кодом.                             |
                                                                           |
========================================================================= */

    var colorizeOnStart = false;     /* true если раскрасить карточки при старте страницы */
    var colorizeItemsMaxcount = 8;   /* сколько цветов раскраски сделано в стилях макета  */

    /* =====================================================================
    |                                                                      |
    |   Получение неких значений:                                          |
    |       список неких узлов                                             |
    |       число цветов с базовым                                         |
    |                                                                      |
    ===================================================================== */

    function getItems ( selector ) {
        if (typeof selector != 'string') selector = 'main .item';
        return document.querySelectorAll(selector);
    };

    function getColorCount () {
        return colorizeItemsMaxcount + 1;
    };

    /* =====================================================================
    |                                                                      |
    |   Поддержка клика на DIV-ссылках класса "info".                      |
    |                                                                      |
    ===================================================================== */

    function anchorInfos () {
        var idx,
            url, urlParam = 'data-href',
            items = getItems('main .item .info[' + urlParam + ']');
        for (idx = 0; idx < items.length; idx++) {
            url = items[idx].getAttribute(urlParam);
            items[idx].setAttribute('onclick', 'gotoLink(\'' + url + '\')');
            items[idx].removeAttribute(urlParam);
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Имитация перехода по ссылке.                                       |
    |                                                                      |
    ===================================================================== */

    function gotoLink ( url ) {
        window.location.replace(url);
        return false;
    };

    /* =====================================================================
    |                                                                      |
    |   Сброс раскраски в карточке публикации.                             |
    |                                                                      |
    ===================================================================== */

    function resetColor ( item ) {
        var num,
            count = getColorCount();
        for (num = 1; num < count; num++) {
            item.classList.remove('color' + num);
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Раскрашивание карточек.                                            |
    |                                                                      |
    ===================================================================== */

    function colorizeItems () {
        var idx, num,
            prev1 = -1, prev2 = -1, prev3 = -1,
            count = getColorCount(),
            items = getItems();
        for (idx = 0; idx < items.length; idx++) {
            resetColor(items[idx]);
            do {
                num = Math.floor(Math.random() * count);
            } while (num == prev1 ||
                     num == prev2 ||
                     num == prev3);
            if (num) items[idx].classList.add('color' + num);
            prev1 = prev2;
            prev2 = prev3;
            prev3 = num;
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Удаление раскраски с карточек.                                     |
    |                                                                      |
    ===================================================================== */

    function uncolorizeItems () {
        var idx,
            items = getItems();
        for (idx = 0; idx < items.length; idx++) {
            resetColor(items[idx]);
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Расширение некоторых карточек.                                     |
    |                                                                      |
    ===================================================================== */

    function resizeItems () {
        var idx, num,
            items = getItems(),
            patternSize = 14;
        for (idx = 0; idx < items.length; idx++) {
            num = idx % patternSize + 1;
            if (num == 1 ||
                num == 4 ||
                num == 9 ||
                num == 10) items[idx].classList.add('wide');
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Аяксовая загрузка следующих карточек.                              |
    |                                                                      |
    ===================================================================== */

    function loadNext ( btn ) {
        return true;
    };

    /* =====================================================================
    |                                                                      |
    |   Скрытие блока пагинации страниц.                                   |
    |                                                                      |
    ===================================================================== */

    function hidePagination () {
        var items = getItems('.pagination');
        for (idx = 0; idx < items.length; idx++) {
            items[idx].setAttribute('hidden', 'hidden');
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Функции для демо режима:                                           |
    |       смена фотографий                                               |
    |       установка заглушки                                             |
    |                                                                      |
    ===================================================================== */

    function demoPhotos ( type, maxcount, ext ) {
        var idx, num = 1, items = getItems('main .item .image img');
        for (idx = 0; idx < items.length; idx++) {
            items[idx].src = themeUrl + 'images/demo/dzen/' + type + '-' + num + '.' + ext;
            num++;
            if (num > maxcount) num = 1;
        }
    };

    function demoMessages ( path, functionName ) {
        var idx, items = getItems(path);
        for (idx = 0; idx < items.length; idx++) {
            items[idx].setAttribute('onclick', 'return ' + functionName + '()');
        }
    };

    /* =====================================================================
    |                                                                      |
    |   Инициализация страницы.                                            |
    |                                                                      |
    ===================================================================== */

    if (colorizeOnStart) colorizeItems();
    resizeItems();
    anchorInfos();
